<?php # $Id: rss.php,v 1.16 2003/11/14 12:27:25 garvinhicking Exp $

header('Content-Type: text/xml');
include_once('serendipity_config.inc.php');
$version = $_GET['version'];
if (empty($version)) {
    $version = '2.0';
}

$description     = $serendipity['blogDescription'];
$title           = $serendipity['blogTitle'];
$comments        = FALSE;
if (isset($_GET['category'])) {
    $serendipity['GET']['category'] = $_GET['category'];
}

if (!isset($_GET['type'])) {
    $_GET['type'] = 'content';
}

switch ($_GET['type']) {
case 'comments':
    $entries     = serendipity_fetchComments(isset($_GET['cid']) ? $_GET['cid'] : null, 15, 'desc');
    $title       = $title . ' ' . COMMENTS;
    $description = COMMENTS_FROM . ' ' . $description;
    $comments    = TRUE;
    break;
case 'content':
default:
    if (isset($_GET['all']) && $_GET['all']) {
        $entries = serendipity_fetchEntries(null, true);
    } else {
        $entries = serendipity_fetchEntries(null, true, 15);
    }
    break;
}

$title       = utf8_encode($title);
$description = utf8_encode($description);

include_once('serendipity_plugin_api.php');
$plugins = serendipity_plugin_api::enum_plugins();

if (is_array($plugins)) {
    // load each plugin to make some introspection
    foreach ($plugins as $plugin_data) {
        if (preg_match('|@serendipity_syndication_plugin|', $plugin_data['name'])) {
            $plugin =& serendipity_plugin_api::load_plugin($plugin_data['name']);
            $additional_fields = $plugin->generate_rss_fields($title, $description, $entries);
            break;
        }
    }
}

echo '<?xml version="1.0" encoding="utf-8" ?>';
echo "\n";
switch ($version) {
case '0.91':
    print <<<HEAD
<rss version="0.91"
  xmlns:robot="http://www.edwardbear.org/def/xml/robot">
<channel>
<title>$title</title>
<link>{$serendipity['baseURL']}</link>
<description>$description</description>
<language>{$serendipity['CONFIG']['lang']}</language>
{$additional_fields['image']}

HEAD;
break;
case '2.0':
    print <<<HEAD
<rss version="2.0/XSS-extensible"
   xmlns="http://purl.org/rss/2.0/"
   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
   xmlns:admin="http://webns.net/mvcb/"
   xmlns:dc="http://purl.org/dc/elements/1.1/"
   xmlns:slash="http://purl.org/rss/1.0/modules/slash/"
   xmlns:wfw="http://wellformedweb.org/CommentAPI/"
   xmlns:content="http://purl.org/rss/1.0/modules/content/"
   xmlns:robot="http://www.edwardbear.org/def/xml/robot">
<channel>
    <title>$title</title>
    <link>{$serendipity['baseURL']}</link>
    <description>$description</description>
    <dc:language>{$serendipity['lang']}</dc:language>
    <admin:errorReportsTo rdf:resource="mailto:{$serendipity['CONFIG']['email']}" />
    <generator>Serendipity - http://www.s9y.org/</generator>
    {$additional_fields['channel']}
    {$additional_fields['image']}

HEAD;
break;
default:
    die("Invalid RSS version specified\n");
}

serendipity_printEntries_rss($entries, $version, $comments);

switch ($version) {
case '0.91':
case '2.0':
    print "</channel>\n";
    print "</rss>\n";
}
/* vim: set sts=4 ts=4 expandtab : */
?>
