<?php # $Id: serendipity_admin_entries.inc.php,v 1.14 2003/11/11 16:17:03 garvinhicking Exp $

##########################################################################
# serendipity - another blogger...                                       #
##########################################################################
#                                                                        #
# (c) 2003 Jannis Hermanns <J@hacked.it>                                 #
# http://www.jannis.to/programming/serendipity.html                      #
#                                                                        #
##########################################################################

if (IN_serendipity !== true) {
    die ("Don't hack!");
}

// A little helper we don't want in _functions.inc.php
function serendipity_drawList($action) {
    global $serendipity;

    // Prepare variables
    if (!is_numeric($serendipity['GET']['offset'])) {
        $serendipity['GET']['offset'] = 0;
    }

    $perPage = 12;

    // Fetch the entries
    $entries = serendipity_fetchEntries(
                 false,
                 false,
                 serendipity_db_limit(
                   $serendipity['GET']['offset'],
                   $perPage
                 ),
                 'true'
               );
    $string_action = ($action == 'delete' ? DELETE_ENTRIES : EDIT_ENTRIES);

    // Prepare table
?>
<div class="serendipity_admin_list">
    <div class="serendipity_admin_list_title"><?php echo $string_action; ?>:</div>

    <table width="100%" class="serendipity_admin_list">
<?php
    if (is_array($entries)) {
        $half = (int) ((count($entries) + 1)/2);

        // Print the browse buttons
?>
        <tr>
            <td>
<?php
        if ($serendipity['GET']['offset'] > 0) {
?>
                <input type="button" value="&lt;&lt;&lt;" onclick="location.href='?serendipity[adminModule]=entries&serendipity[adminAction]=<?php echo $serendipity['GET']['adminAction']; ?>&serendipity[offset]=<?php echo max(0, ($serendipity['GET']['offset'] - $perPage)); ?>';" />
<?php
        }
?>
            </td>

            <td align="right">
<?php
        if (count($entries) == $perPage) {
?>
                <input type="button" value="&gt;&gt;&gt;" onclick="location.href='?serendipity[adminModule]=entries&serendipity[adminAction]=<?php echo $serendipity['GET']['adminAction']; ?>&serendipity[offset]=<?php echo $serendipity['GET']['offset'] + $perPage; ?>';" />
<?php
        }
?>
            </td>
        </tr>
<?php
        // Print the entries
        $count = count($entries);
        for ($x=0; $x < $half; $x++) {
?>
        <tr>
            <td class="serendipity_admin_list_item">
                <?php echo date('d.m.y, H:i', $entries[$x]['timestamp']) . ': '; ?>
                <br />
                <?php if ($entries[$x]['isdraft'] == 'true') echo DRAFT . ':'; ?>
                <a href="?serendipity[action]=admin&amp;serendipity[adminModule]=entries&amp;serendipity[adminAction]=<?php echo $action; ?>&amp;serendipity[id]=<?php echo $entries[$x]['id']; ?>">
                    <?php echo htmlentities(substr(empty($entries[$x]['title']) ? $entries[$x]['body'] : $entries[$x]['title'], 0, 40)); ?>
                </a>
            </td>

            <td class="serendipity_admin_list_item">
<?php
            if ($x + $half < $count) {
?>
                <?php echo date('d.m.y, H:i', $entries[$x + $half]['timestamp']) . ': '; ?>
                <br />
                <?php if ($entries[$x + $half]['isdraft'] == 'true') echo DRAFT . ':'; ?>
                <a href="?serendipity[action]=admin&amp;serendipity[adminModule]=entries&amp;serendipity[adminAction]=<?php echo $action; ?>&amp;serendipity[id]=<?php echo $entries[$x + $half]['id']; ?>">
                    <?php echo htmlentities(substr($entries[$x + $half]['title'], 0, 40)); ?>
                </a>
<?php
            }
?>
            </td>
        </tr>
<?php
        }
    } else {
        // We've got nothing
?>
        <tr>
            <td class="serendipity_admin_list_item" colspan="2">
                <?php echo NO_ENTRIES_TO_PRINT ?>
            </td>
        </tr>
<?php
    }
?>
    </table>
</div>
<?php
}

switch($serendipity['GET']['adminAction']) {
    case 'save':
        $entry = array(
                   'id'             => $serendipity['POST']['id'],
                   'title'          => $serendipity['POST']['title'],
                   'timestamp'      => $serendipity['POST']['timestamp'],
                   'body'           => $serendipity['POST']['body'],
                   'extended'       => $serendipity['POST']['extended'],
                   'categoryid'     => $serendipity['POST']['categoryid'],
                   'isdraft'        => $serendipity['POST']['isdraft'],
                   'allow_comments' => $serendipity['POST']['allow_comments']
        );

        if ($entry['allow_comments'] != 'true' && $entry['allow_comments'] !== true) {
            $entry['allow_comments'] = 'false';
        }

        // Check if the user changed the timestamp.
        if (isset($serendipity['allowDateManipulation']) && $serendipity['allowDateManipulation'] && isset($serendipity['POST']['new_timestamp']) && $serendipity['POST']['new_timestamp'] != date(DATE_FORMAT_2, $serendipity['POST']['chk_timestamp'])) {
            // The user changed the timestamp, now set the DB-timestamp to the user's date
            $entry['timestamp'] = strtotime($serendipity['POST']['new_timestamp']);

            if ($entry['timestamp'] == -1) {
                echo DATE_INVALID . '<br />';
                // The date given by the user is not convertable. Reset the timestamp.
                $entry['timestamp'] = $serendipity['POST']['timestamp'];
            }
        }

        // Save the entry, or just display a preview
        if ($serendipity['POST']['preview'] != 'true') {
            $res = serendipity_updertEntry($entry);
            if (is_string($res)) {
                serendipity_printEntryForm(
                  '?',
                  array(
                    'serendipity[action]'      => 'admin',
                    'serendipity[adminModule]' => 'entries',
                    'serendipity[adminAction]' => 'save'
                  ),
                  $entry,
                  ERROR . ': <b>' . $res . '</b>');
            } else {
                echo ENTRY_SAVED;
            }
        } else {
            // Only display the preview
            if (!is_numeric($entry['timestamp'])) $entry['timestamp']  = time();
            if (!$entry['trackbacks'])            $entry['trackbacks'] = 0;
            if (!$entry['comments'])              $entry['comments']   = 0;
            if (!$entry['username'])              $entry['username']   = $serendipity['serendipityUser'];

            echo '<strong>' . PREVIEW . '</strong>';
            echo '<div style="border:1px solid #000000; padding: 15px;">';
            serendipity_printEntries(array($entry), ($entry['extended'] != '' ? 1 : 0));
            echo '</div>';

            serendipity_printEntryForm(
                '?',
                array(
                  'serendipity[action]'      => 'admin',
                  'serendipity[adminModule]' => 'entries',
                  'serendipity[adminAction]' => 'save',
                  'serendipity[timestamp]'   => $entry['timestamp']
                ),

                $entry
            );
        }
        break;

    case 'editSelect':
        serendipity_drawList('edit');
        break;

    case 'deleteSelect':
        serendipity_drawList('delete');
        break;

    case 'delete':
        $newLoc = '?serendipity[action]=admin&amp;serendipity[adminModule]=entries&amp;serendipity[adminAction]=doDelete&amp;serendipity[id]=' . $serendipity['GET']['id'];
        printf(DELETE_SURE, $serendipity['GET']['id']);
?>
<br />
<div>
    <input type="button" value="<?php echo NOT_REALLY; ?>" onclick="history.go(-1);" />
    <span style="width: 50px;"></span>
    <input type="button" value="<?php echo DUMP_IT; ?>" onclick="location.href='<?php echo $newLoc; ?>'" />
</div>
<?php
        break;

    case 'doDelete':
        serendipity_deleteEntry($serendipity['GET']['id']);
        printf(RIP_ENTRY, $serendipity['GET']['id']);
        break;

    case 'edit':
        $entry = serendipity_fetchEntry('id', $serendipity['GET']['id']);
    default:
        serendipity_printEntryForm(
            '?',
            array(
            'serendipity[action]'      => 'admin',
            'serendipity[adminModule]' => 'entries',
            'serendipity[adminAction]' => 'save'
            ),
            (isset($entry) ? $entry : array())
        );
}
/* vim: set sts=4 ts=4 expandtab : */
?>
