<?php # $Id: serendipity_db_sqlite.inc.php,v 1.6 2003/07/25 01:03:18 jtate Exp $

function serendipity_db_connect()
{
    global $serendipity;
    
    $serendipity['dbConn'] = sqlite_open($serendipity['serendipityPath'] . 'sqlite.db');
}

function serendipity_db_escape_string($string)
{
    static $search  = array("\x00", '%',   '\'',   '\"');
    static $replace = array('%00',  '%25', '\\\'', '\\\"');
    
    return str_replace($search, $replace, $string);
}

function serendipity_db_affected_rows()
{
    return sqlite_changes($GLOBALS['serendipity']['dbConn']);
}

function serendipity_db_insert_id()
{
    return sqlite_last_insert_rowid($GLOBALS['serendipity']['dbConn']);
}

function serendipity_db_sqlite_fetch_array($res)
{
    static $search  = array('%00',  '%25');
    static $replace = array("\x00", '%');
    
    $row = sqlite_fetch_array($res);
    if (!is_array($row)) {
        return $row;
    }
    
    /* strip any slashes */
    $r = array();
    foreach ($row as $i => $v) {
        $r[$i] = str_replace($search, $replace, $v);
    }

    return $r;
}

function serendipity_db_query($sql, $single = false, $result_type = "both")
{
    global $serendipity;
    
    $res = sqlite_exec($sql, $serendipity['dbConn']);
    if (!$res) {
        if (!$serendipity['production']) {
            var_dump($res);
            var_dump($sql);
            return "problem with query";
        }
        return false;
    }
    
    if ($res === true) {
        return true;
    }
    
    $rows = array();
    
    if ($result_type == 'num') {
        while (($row = serendipity_db_sqlite_fetch_array($res))) {
            $rows[] = $row;
        }
    } else {
    
        $field_names = serendipity_db_sqlite_fetch_array($res);
    
        if ($result_type == 'both') {
            while (($row = sqlite_fetch_array($res))) {
                foreach ($field_names as $i => $name) {
                    $row[$name] = $row[$i];
                }
                $rows[] = $row;
            }
        } else {

            /* string keys only */
            while (($row = serendipity_db_sqlite_fetch_array($res))) {
                $r = array();
                foreach ($field_names as $i => $name) {
                    $r[$name] = $row[$i];
                }
                $rows[] = $r;
            }
        }
    }
    
    if ($single && count($rows) == 0) {
        return false;
    }
    
    if ($single && count($rows) == 1) {
        return $rows[0];
    }
    
    return $rows;
}

function serendipity_db_probe($hash, &$errs)
{
    global $serendipity;
    
    $serendipity['dbConn'] = sqlite_open($serendipity['serendipityPath'] . 'sqlite.db');

    if ($serendipity['dbConn']) {
        return true;
    }

    $errs[] = "Unable to open \"{$serendipity['serendipityPath']}sqlite.db\" - check permissions!";
    return false;
}

function serendipity_db_schema_import($query)
{
    static $search  = array('{AUTOINCREMENT}', '{PRIMARY}', '{UNSIGNED}', '{FULLTEXT}');
    static $replace = array('INTEGER', 'PRIMARY KEY', '', '');

    return serendipity_db_query(str_replace($search, $replace, $query));
}

/* vim: set sts=4 ts=4 expandtab : */
?>
