<?php # $Id: serendipity_sidebar_items.php,v 1.32 2003/11/11 16:17:05 garvinhicking Exp $

class serendipity_calendar_plugin extends serendipity_plugin {
    function introspect(&$propbag)
    {
        $propbag->add('name',        CALENDAR);
        $propbag->add('description', QUICKJUMP_CALENDAR);
    }

    function generate_content(&$title)
    {
        global $serendipity;

        $title = QUICKJUMP;

        if (!isset($serendipity['GET']['calendarZoom'])) {
            if (!isset($serendipity['GET']['range'])) {
                $serendipity['GET']['calendarZoom'] = date('Y') . date('m');
            } else {
                $serendipity['GET']['calendarZoom'] = $serendipity['GET']['range'];
            }
        }

        serendipity_drawCalendar(
          substr(
            (isset($serendipity['GET']['calendarZoom']) ? $serendipity['GET']['calendarZoom'] : ''),
            4,
            2
          ),
          substr(
            (isset($serendipity['GET']['calendarZoom']) ? $serendipity['GET']['calendarZoom'] : ''),
            0,
            4
          )
        );
    }
}

class serendipity_quicksearch_plugin extends serendipity_plugin {
    function introspect(&$propbag)
    {
        $propbag->add('name',        QUICKSEARCH);
        $propbag->add('description', SEARCH_FOR_ENTRY);
    }

    function generate_content(&$title)
    {
        global $serendipity;

        $title = QUICKSEARCH;
?>
<form action="<?php echo $serendipity['serendipityHTTPPath']; ?>search.php" method="get">
    <div>
        <input type="hidden" name="serendipity[action]" value="search" />
        <input type="text"   name="serendipity[searchTerm]" onfocus="value='';" size="13" />
    </div>
</form>
<?php
    }
}

class serendipity_archives_plugin extends serendipity_plugin {
    function introspect(&$propbag)
    {
        $propbag->add('name',        ARCHIVES);
        $propbag->add('description', BROWSE_ARCHIVES);
    }

    function generate_content(&$title)
    {
        global $serendipity;

        $title = ARCHIVES;

        $ts = mktime(0, 0, 0, (date('m')+1), 1, date('Y'));

        for($x = 0; $x < 3; $x++) {
            $ts -= 1;

            if ($serendipity['rewrite'] === true) {
                $link = $serendipity['serendipityHTTPPath'] . 'archives/' . date('Ym', $ts) . '.html';
            } else {
                $link = 'fixme';
            }

            $ts_title = $serendipity['months'][date('n', $ts)] . ' ' . date('Y', $ts);

            echo '<a href="' . $link . '" title="' . $ts_title . '">' . $ts_title . '</a><br />' . "\n";

            $ts = mktime(0, 0, 0, date('m', $ts), 1, date('Y', $ts));
        }

        echo "<a href='{$serendipity['serendipityHTTPPath']}'>" . RECENT . "</a><br />\n";
        echo "<a href='{$serendipity['serendipityHTTPPath']}archive'>" . OLDER . "</a>\n";
    }
}

class serendipity_topreferrers_plugin extends serendipity_plugin {
    function introspect(&$propbag)
    {
        $propbag->add('name',        TOP_REFERRER);
        $propbag->add('description', SHOWS_TOP_SITES);
    }

    function generate_content(&$title)
    {
        global $serendipity;

        $title = TOP_REFERRER;
        echo serendipity_displayTopReferrers();
    }
}

class serendipity_topexits_plugin extends serendipity_plugin {
    function introspect(&$propbag)
    {
        $propbag->add('name',        TOP_EXITS);
        $propbag->add('description', SHOWS_TOP_EXIT);
    }

    function generate_content(&$title)
    {
        global $serendipity;

        $title = TOP_EXITS;
        echo serendipity_displayTopExits();
    }
}

class serendipity_syndication_plugin extends serendipity_plugin {
    function introspect(&$propbag)
    {
        $propbag->add('name',        SYNDICATION);
        $propbag->add('description', SHOWS_RSS_BLAHBLAH);
        $propbag->add('configuration', array(
                                        'show_0.91',
                                        'show_2.0',
                                        'show_2.0c',
                                        'seperator',
                                        'field_managingEditor',
                                        'field_webMaster',
                                        'field_ttl',
                                        'field_pubDate',
                                        'seperator',
                                        'bannerURL',
                                        'bannerWidth',
                                        'bannerHeight',
                                       )
        );
    }

    function introspect_config_item($name, &$propbag)
    {
        switch($name) {
            case 'show_0.91':
                $propbag->add('type',        'boolean');
                $propbag->add('name',        SYNDICATION_PLUGIN_091);
                $propbag->add('description', '');
                break;

            case 'show_2.0':
                $propbag->add('type',        'boolean');
                $propbag->add('name',        SYNDICATION_PLUGIN_20);
                $propbag->add('description', '');
                break;

            case 'show_2.0c':
                $propbag->add('type',        'boolean');
                $propbag->add('name',        SYNDICATION_PLUGIN_20c);
                $propbag->add('description', '');
                break;

            case 'seperator':
                $propbag->add('type',        'seperator');
                break;

            case 'field_managingEditor':
                $propbag->add('type',        'string');
                $propbag->add('name',        SYNDICATION_PLUGIN_MANAGINGEDITOR);
                $propbag->add('description', SYNDICATION_PLUGIN_MANAGINGEDITOR_DESC);
                break;

            case 'field_webMaster':
                $propbag->add('type',        'string');
                $propbag->add('name',        SYNDICATION_PLUGIN_WEBMASTER);
                $propbag->add('description', SYNDICATION_PLUGIN_WEBMASTER_DESC);
                break;

            case 'field_ttl':
                $propbag->add('type',        'string');
                $propbag->add('name',        SYNDICATION_PLUGIN_TTL);
                $propbag->add('description', SYNDICATION_PLUGIN_TTL_DESC);
                break;

            case 'field_pubDate':
                $propbag->add('type',        'boolean');
                $propbag->add('name',        SYNDICATION_PLUGIN_PUBDATE);
                $propbag->add('description', SYNDICATION_PLUGIN_PUBDATE_DESC);
                break;

            case 'bannerURL':
                $propbag->add('type',        'string');
                $propbag->add('name',        SYNDICATION_PLUGIN_BANNERURL);
                $propbag->add('description', SYNDICATION_PLUGIN_BANNERURL_DESC);
                break;

            case 'bannerWidth':
                $propbag->add('type',        'string');
                $propbag->add('name',        SYNDICATION_PLUGIN_BANNERWIDTH);
                $propbag->add('description', SYNDICATION_PLUGIN_BANNERWIDTH_DESC);
                break;

            case 'bannerHeight':
                $propbag->add('type',        'string');
                $propbag->add('name',        SYNDICATION_PLUGIN_BANNERHEIGHT);
                $propbag->add('description', SYNDICATION_PLUGIN_BANNERHEIGHT_DESC);
                break;

            default:
                return false;
        }
        return true;
    }

    function generate_content(&$title)
    {
        global $serendipity;

        $title = SYNDICATE_THIS_BLOG;

        if ($this->get_config('show_0.91') != 'false') {
?>
            <a href="<?php echo $serendipity['serendipityHTTPPath']; ?>rss.php?version=0.91"><img src="<?php echo $serendipity['serendipityHTTPPath']; ?>xml.gif" border="0" alt="XML" /></a>
            <a href="<?php echo $serendipity['serendipityHTTPPath']; ?>rss.php?version=0.91">RSS 0.91 feed</a>
            <br />
<?php
        }

        if ($this->get_config('show_2.0') != 'false') {
?>
            <a href="<?php echo $serendipity['serendipityHTTPPath']; ?>rss.php?version=2.0"><img src="<?php echo $serendipity['serendipityHTTPPath']; ?>xml.gif" border="0" alt="XML" /></a>
            <a href="<?php echo $serendipity['serendipityHTTPPath']; ?>rss.php?version=2.0">RSS 2.0 feed</a>
            <br />
<?php
        }

        if ($this->get_config('show_2.0c') != 'false') {
?>
            <a href="<?php echo $serendipity['serendipityHTTPPath']; ?>rss.php?version=2.0&amp;type=comments"><img src="<?php echo $serendipity['serendipityHTTPPath']; ?>xml.gif" border="0" alt="XML" /></a>
            <a href="<?php echo $serendipity['serendipityHTTPPath']; ?>rss.php?version=2.0&amp;type=comments"><?php echo ($serendipity['XHTML11'] ? '<span style="white-space: nowrap">' : '<nobr>'); ?>RSS 2.0 <?php echo COMMENTS; ?><?php echo ($serendipity['XHTML11'] ? '</span>' : '</nobr>'); ?></a>
<?php
        }
    }

    function generate_rss_fields(&$title, &$description, &$entries) {
        global $serendipity;
        // Check for a logo to use for an RSS feed. Can either be set by configuring the
        // syndication plugin OR by just placing a rss_banner.png file in the pixel directory.
        // If both is not set, we will display our happy own branding. :-)

        $bag    = new serendipity_property_bag;
        $this->introspect($bag);
        $additional_fields = array();

        if ($this->get_config('bannerURL') != '') {
            $img   = $this->get_config('bannerURL');
            $w     = $this->get_config('bannerWidth');
            $h     = $this->get_config('bannerHeight');
            $additional_fields['image'] = <<<IMAGE
<image>
        <url>$img</url>
        <title>RSS: $title - $description</title>
        <link>{$serendipity['baseURL']}</link>
        <width>$w</width>
        <height>$h</height>
    </image>
IMAGE;
        } elseif (file_exists($serendipity['serendipityPath'] . 'pixel/rss_banner.png')) {
            $i = getimagesize($serendipity['serendipityPath'] . 'pixel/rss_banner.png');
            $additional_fields['image'] = <<<IMAGE
<image>
        <url>{$serendipity['baseURL']}pixel/rss_banner.png</url>
        <title>RSS: $title - $description</title>
        <link>{$serendipity['baseURL']}</link>
        <width>{$i[0]}</width>
        <height>{$i[1]}</height>
    </image>
IMAGE;
        } else {
            $additional_fields['image'] = <<<IMAGE
<image>
        <url>{$serendipity['baseURL']}pixel/s9y_banner_tiny.png</url>
        <title>RSS: $title - $description</title>
        <link>{$serendipity['baseURL']}</link>
        <width>100</width>
        <height>21</height>
    </image>
IMAGE;
        }

        // Now, if set, stitch together any fields that have been configured in the syndication plugin.
        // First, do some sanity checks
        $additional_fields['channel'] = '';
        foreach($bag->get('configuration') AS $bag_index => $bag_value) {
            if (preg_match('|^field_(.*)$|', $bag_value, $match)) {
                $bag_content = $this->get_config($bag_value);

                switch($match[1]) {
                    case 'pubDate':
                        if ($bag_content != 'false') {
                            $bag_content = date('r', $entries[0]['timestamp']);
                        } else {
                            $bag_content = '';
                        }
                        break;

                    // Each new RSS-field which needs rewrite of its content should get its own case here.

                    default:
                        break;
                }

                if ($bag_content != '') {
                    $additional_fields['channel'] .= '<' . $match[1] . '>' . $bag_content . '</' . $match[1] . '>' . "\n";
                }

            }
        }

        return $additional_fields;
    }
}

class serendipity_superuser_plugin extends serendipity_plugin {
    function introspect(&$propbag)
    {
        $propbag->add('name',        SUPERUSER);
        $propbag->add('description', ALLOWS_YOU_BLAHBLAH);
    }

    function generate_content(&$title)
    {
        global $serendipity;

        $title = SUPERUSER . ':';
        echo "<a href=\"{$serendipity['serendipityHTTPPath']}entries\" title=\"$title\">\$ su -</a>";
    }
}

class serendipity_plug_plugin extends serendipity_plugin {
    function introspect(&$propbag)
    {
        $propbag->add('name',        POWERED_BY);
        $propbag->add('description', ADVERTISES_BLAHBLAH);
    }

    function generate_content(&$title)
    {
        global $serendipity;

        $title = POWERED_BY . ":";
?>
<div class="serendipityPlug">
    <a title=":serendipity" href="http://www.s9y.org/"><img src="<?php echo $serendipity['serendipityHTTPPath']; ?>pixel/s9y_banner_tiny.png" alt=":serendipity" border="0" /></a>
</div>
<?php
    }
}

class serendipity_html_nugget_plugin extends serendipity_plugin {
    function introspect(&$propbag)
    {
        $propbag->add('name',          HTML_NUGGET);
        $propbag->add('description',   HOLDS_A_BLAHBLAH);
        $propbag->add('configuration', array(
                                        'title',
                                        'content',
                                       )
        );
    }

    function introspect_config_item($name, &$propbag)
    {
        switch($name) {
            case 'title':
                $propbag->add('type',        'string');
                $propbag->add('name',        TITLE);
                $propbag->add('description', TITLE_FOR_NUGGET);
                break;

            case 'content':
                $propbag->add('type',        'html');
                $propbag->add('name',        CONTENT);
                $propbag->add('description', THE_NUGGET);
                break;

            default:
                return false;
        }
        return true;
    }

    function generate_content(&$title)
    {
        $title = $this->get_config('title', $title);
        echo serendipity_markup_text($this->get_config('content'));
    }
}

class serendipity_categories_plugin extends serendipity_plugin {
    function introspect(&$propbag) {
        global $serendipity;

        $propbag->add('name',        CATEGORIES);
        $propbag->add('description', CATEGORY_PLUGIN_DESC);
        $propbag->add('configuration', array('authorid'));

        $row_authors = serendipity_db_query("SELECT username, authorid FROM {$serendipity['dbPrefix']}authors");
        $authors     = array('all' => ALL_AUTHORS);
        foreach($row_authors AS $rownr => $row) {
            $authors[$row['authorid']] = $row['username'];
        }

        $this->select_values = $authors;
    }

    function introspect_config_item($name, &$propbag)
    {
        switch($name) {
            case 'authorid':
                $propbag->add('type',        'select');
                $propbag->add('name',        CATEGORIES_TO_FETCH);
                $propbag->add('description', CATEGORIES_TO_FETCH_DESC);
                break;

            default:
                return false;
        }
        return true;
    }

    function generate_content(&$title) {
        global $serendipity;

        $categories = serendipity_fetchCategories($this->get_config('authorid'));
        $title      = CATEGORIES;
        $html       = '';

        if (is_array($categories) && count($categories)) {
            foreach ($categories as $category) {
                $category_id = serendipity_makeFilename($category['category_name']);

                $html .= sprintf(
                  '<a href="%s" title="%s"><img style="display: inline;" alt="xml" border="0" src="%s" /></a>&nbsp;' .
                  '<a href="%s" title="%s">%s</a><br />',

                  $serendipity['serendipityHTTPPath'] . 'rss.php?category=' . $category['categoryid'] . '_' . $category_id,
                  htmlentities($category['category_description']),
                  $serendipity['serendipityHTTPPath'] . 'xml.gif',
                  $serendipity['serendipityHTTPPath'] . 'categories/' . $category['categoryid'] . '_' . $category_id,
                  htmlentities($category['category_description']),
                  $category['category_name']
                );
            }
        }

        $html .= sprintf(
            '<br /><a href="%s" title="%s">%s</a>',

            $serendipity['serendipityHTTPPath'] . $serendipity['indexFile'],
            ALL_CATEGORIES,
            ALL_CATEGORIES
        );

        print $html;
    }
}

/* vim: set sts=4 ts=4 expandtab : */
?>
